%
%  response = applyKernel(img,filtermodel)
%
%  applies the filter given by filtermodel on the given image img.
% 
%  returns reponses with positive rotation behavior in destRe
%  and negative in destIm.
%


function [destRe destIm] = applyKernel(img,filtermodel)

% convolve with basis kernel
g = gaussBasisFilt(size(img),filtermodel.gwid);
g = ifft2(g .* fft2(img));


alpha = filtermodel.alpha;

%% compute derivatives
if filtermodel.realfilter == 0,
    [destRe destIm] = ComplexFilter(g,alpha,filtermodel.order,filtermodel.fw,0);
else,
    alpha = alpha - diag(diag(alpha))/2;
    [destRe] = ComplexFilter(g,alpha,filtermodel.order,filtermodel.fw,0,1);
end;


